/*
	POCKET SINGER ̃f[^ RpC
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>
#include <string.h>
#include "hex.h"

#define FALSE	0	/* U */
#define TRUE	1	/* ^ */

#define COMMAND_R	1000	/* x */
#define COMMAND_T	1001	/* e| */
#define COMMAND_L	1002	/*  */
#define COMMAND_Q	1003	/* Q */
#define COMMAND_O	1004	/* IN^[u */
#define COMMAND_INC	1005	/* 1IN^[uグ */
#define COMMAND_DEC	1006	/* 1IN^[u */
#define COMMAND_TRANS	1007	/* ڒ (+) */
#define COMMAND_TRANS_MINUS	1008	/* ڒ (-) */

#define ADDRESS	0x2e23	/* ̃f[^̐擪AhX */

/*
	󔒂ǂݔ΂
*/
static void skipBlank(char **p)
{
	while(isspace((unsigned char )**p) || **p == '\r' || **p == '\n')
		(*p)++;
}

/*
	𓾂
*/
static int getSound(int *command, int *length, int *period, int *slur, char **p)
{
	char buf[16], *q;

	/* 󔒂ǂݔ΂ */
	skipBlank(p);

	/* R}h𓾂 */
	if(strncasecmp(*p, "c-", 2) == 0) {
		*command = -1;
		(*p) += 2;
	} else if(strncasecmp(*p, "c+", 2) == 0) {
		*command = 1;
		(*p) += 2;
	} else if(strncasecmp(*p, "d-", 2) == 0) {
		*command = 1;
		(*p) += 2;
	} else if(strncasecmp(*p, "d+", 2) == 0) {
		*command = 3;
		(*p) += 2;
	} else if(strncasecmp(*p, "e-", 2) == 0) {
		*command = 3;
		(*p) += 2;
	} else if(strncasecmp(*p, "e+", 2) == 0) {
		*command = 5;
		(*p) += 2;
	} else if(strncasecmp(*p, "f-", 2) == 0) {
		*command = 4;
		(*p) += 2;
	} else if(strncasecmp(*p, "f+", 2) == 0) {
		*command = 6;
		(*p) += 2;
	} else if(strncasecmp(*p, "g-", 2) == 0) {
		*command = 6;
		(*p) += 2;
	} else if(strncasecmp(*p, "g+", 2) == 0) {
		*command = 8;
		(*p) += 2;
	} else if(strncasecmp(*p, "a-", 2) == 0) {
		*command = 8;
		(*p) += 2;
	} else if(strncasecmp(*p, "a+", 2) == 0) {
		*command = 10;
		(*p) += 2;
	} else if(strncasecmp(*p, "b-", 2) == 0) {
		*command = 10;
		(*p) += 2;
	} else if(strncasecmp(*p, "b+", 2) == 0) {
		*command = 12;
		(*p) += 2;
	} else if(strncasecmp(*p, "_-", 2) == 0) {
		*command = COMMAND_TRANS_MINUS;
		(*p) += 2;
	} else if(strncasecmp(*p, "c", 1) == 0) {
		*command = 0;
		(*p)++;
	} else if(strncasecmp(*p, "d", 1) == 0) {
		*command = 2;
		(*p)++;
	} else if(strncasecmp(*p, "e", 1) == 0) {
		*command = 4;
		(*p)++;
	} else if(strncasecmp(*p, "f", 1) == 0) {
		*command = 5;
		(*p)++;
	} else if(strncasecmp(*p, "g", 1) == 0) {
		*command = 7;
		(*p)++;
	} else if(strncasecmp(*p, "a", 1) == 0) {
		*command = 9;
		(*p)++;
	} else if(strncasecmp(*p, "b", 1) == 0) {
		*command = 11;
		(*p)++;
	} else if(strncasecmp(*p, "r", 1) == 0 || strncasecmp(*p, "p", 1) == 0) {
		*command = COMMAND_R;
		(*p)++;
	} else if(strncasecmp(*p, "t", 1) == 0) {
		*command = COMMAND_T;
		(*p)++;
	} else if(strncasecmp(*p, "l", 1) == 0) {
		*command = COMMAND_L;
		(*p)++;
	} else if(strncasecmp(*p, "q", 1) == 0) {
		*command = COMMAND_Q;
		(*p)++;
	} else if(strncasecmp(*p, "o", 1) == 0) {
		*command = COMMAND_O;
		(*p)++;
	} else if(strncasecmp(*p, ">", 1) == 0) {
		*command = COMMAND_INC;
		(*p)++;
	} else if(strncasecmp(*p, "<", 1) == 0) {
		*command = COMMAND_DEC;
		(*p)++;
	} else if(strncasecmp(*p, "_", 1) == 0) {
		*command = COMMAND_TRANS;
		(*p)++;
	} else
		return FALSE;

	/* 𓾂 */
	for(q = buf; q < buf + sizeof(buf) - 1 && isdigit(**p); q++, (*p)++)
		*q = **p;
	*q = 0;
	*length = atoi(buf);

	/* t_邩? */
	if(**p == '.') {
		*period = TRUE;
		(*p)++;
	} else
		*period = FALSE;

	/* X[邩? */
	if(**p == '^' || **p == '&') {
		*slur = TRUE;
		(*p)++;
	} else
		*slur = FALSE;
	return TRUE;
}

/*
	𓾂
*/
static int getVoice(int *command, char **p)
{
	static const struct {
		char *ch; /*  */
		int command; /* R}h */
	} table[] = {
		{ "b", 0 }, { "", 0 }, { "", 0 },
		{ "A", 6 }, { "", 6 }, { "", 6 },
		{ "C", 7 }, { "", 7 }, { "", 7 },
		{ "E", 8 }, { "", 8 }, { "", 8 },
		{ "G", 9 }, { "", 9 }, { "", 9 },
		{ "I", 10 }, { "", 10 }, { "", 10 },
		{ "", 10 }, { "", 10 }, { "", 10 },
		{ "J", 11 }, { "", 11 }, { "", 11 },
		{ "L", 12 }, { "", 12 }, { "", 12 },
		{ "N", 13 }, { "", 13 }, { "", 13 },
		{ "P", 14 }, { "", 14 }, { "", 14 },
		{ "R", 15 }, { "", 15 }, { "", 15 },
		{ "L", 16 }, { "", 16 }, { "", 16 },
		{ "L", 17 }, { "", 17 }, { "", 17 },
		{ "LF", 18 }, { "", 18 }, { "", 18 },
		{ "L", 19 }, { "", 19 }, { "", 19 },
		{ "N@", 20 }, { "", 20 }, { "", 20 },
		{ "NB", 21 }, { "", 21 }, { "", 21 },
		{ "NF", 22 }, { "", 22 }, { "", 22 },
		{ "NH", 23 }, { "", 23 }, { "", 23 },
		{ "K", 24 }, { "", 24 }, { "", 24 },
		{ "M", 25 }, { "", 25 }, { "", 25 },
		{ "O" ,26 }, { "", 26 }, { "", 26 },
		{ "Q", 27 }, { "", 27 }, { "", 27 },
		{ "S", 28 }, { "", 28 }, { "", 28 },
		{ "M", 29 }, { "ެ", 29 }, { "", 29 },
		{ "M", 30 }, { "ޭ", 30 }, { "", 30 },
		{ "MF", 31 }, { "ު", 31 }, { "", 31 },
		{ "M", 32 }, { "ޮ", 32 }, { "", 32 },
		{ "T", 33 }, { "", 33 }, { "", 33 },
		{ "V", 34 }, { "", 34 }, { "", 34 },
		{ "X", 35 }, { "", 35 }, { "", 35 },
		{ "Z", 36 }, { "", 36 }, { "", 36 },
		{ "\", 37 }, { "", 37 }, { "", 37 },
		{ "V", 38 }, { "", 38 }, { "", 38 },
		{ "XB", 39 }, { "", 39 }, { "", 39 },
		{ "V", 40 }, { "", 40 }, { "", 40 },
		{ "VF", 41 }, { "", 41 }, { "", 41 },
		{ "V", 42 }, { "", 42 }, { "", 42 },
		{ "U", 43 }, { "", 43 }, { "", 43 },
		{ "W", 44 }, { "", 44 }, { "", 44 },
		{ "Y", 45 }, { "", 45 }, { "", 45 },
		{ "[", 46 }, { "", 46 }, { "", 46 },
		{ "]", 47 }, { "", 47 }, { "", 47 },
		{ "W", 48 }, { "ެ", 48 }, { "", 49 },
		{ "YB", 49 }, { "ި", 49 }, { "", 49 },
		{ "W", 50 }, { "ޭ", 50 }, { "", 50 },
		{ "WF", 51 }, { "ު", 51 }, { "", 51 },
		{ "W", 52 }, { "ޮ", 52 }, { "", 52 },
		{ "^", 53 }, { "", 53 }, { "", 53 },
		{ "`", 54 }, { "", 54 }, { "", 54 },
		{ "c", 55 }, { "", 55 }, { "", 55 },
		{ "e", 56 }, { "", 56 }, { "", 56 },
		{ "g", 57 }, { "", 57 }, { "", 57 },
		{ "e", 58 }, { "ì", 58 }, { "Ă", 58 },
		{ "eB", 59 }, { "è", 59 }, { "Ă", 59 },
		{ "e", 60 }, { "í", 60 }, { "Ă", 60 },
		{ "eF", 61 }, { "ê", 61 }, { "Ă", 61 },
		{ "e", 62 }, { "î", 62 }, { "Ă", 62 },
		{ "gD", 63 }, { "ĩ", 63 }, { "Ƃ", 63 },
		{ "c@", 64 }, { "§", 64 }, { "", 64 },
		{ "cB", 65 }, { "¨", 65 }, { "", 65 },
		{ "cF", 66 }, { "ª", 66 }, { "", 66 },
		{ "cH", 67 }, { "«", 67 }, { "", 67 },
		{ "_", 68 }, { "", 68 }, { "", 68 },
		{ "a", 44 }, { "", 44 }, { "", 44 },
		{ "d", 45 }, { "", 45 }, { "", 45 },
		{ "f", 69 }, { "", 69 }, { "", 69 },
		{ "h", 70 }, { "", 70 }, { "", 70 },
		{ "f", 71 }, { "ެ", 71 }, { "ł", 71 },
		{ "fB", 72 }, { "ި", 72 }, { "ł", 72 },
		{ "f", 73 }, { "ޭ", 73 }, { "ł", 73 },
		{ "fF", 74 }, { "ު", 74 }, { "ł", 74 },
		{ "f", 75 }, { "ޮ", 75 }, { "ł", 75 },
		{ "hD", 76 }, { "ީ", 76 }, { "ǂ", 76 },
		{ "`", 77 }, { "", 77 }, { "", 77 },
		{ "`", 78 }, { "", 78 }, { "", 78 },
		{ "`F", 79 }, { "", 79 }, { "", 79 },
		{ "`", 80 }, { "", 80 }, { "", 80 },
		{ "i", 81 }, { "", 81 }, { "", 81 },
		{ "j", 82 }, { "", 82 }, { "", 82 },
		{ "k", 83 }, { "", 83 }, { "", 83 },
		{ "l", 84 }, { "", 84 }, { "", 84 },
		{ "m", 85 }, { "", 85 }, { "", 85 },
		{ "j", 86 }, { "Ƭ", 86 }, { "ɂ", 86 },
		{ "j", 87 }, { "ƭ", 87 }, { "ɂ", 87 },
		{ "jF", 88 }, { "ƪ", 88 }, { "ɂ", 88 },
		{ "j", 89 }, { "Ʈ", 89 }, { "ɂ", 89 },
		{ "n", 90 }, { "", 90 }, { "", 90 },
		{ "q", 91 }, { "", 91 }, { "", 91 },
		{ "t", 92 }, { "", 92 }, { "", 92 },
		{ "w", 93 }, { "", 93 }, { "", 93 },
		{ "z", 94 }, { "", 94 }, { "", 94 },
		{ "q", 95 }, { "ˬ", 95 }, { "Ђ", 95 },
		{ "q", 96 }, { "˭", 96 }, { "Ђ", 96 },
		{ "qF", 97 }, { "˪", 97 }, { "Ђ", 97 },
		{ "q", 98 }, { "ˮ", 98 }, { "Ђ", 98 },
		{ "t@", 99 }, { "̧", 99 }, { "ӂ", 99 },
		{ "tB", 100 }, { "̨", 100 }, { "ӂ", 100 },
		{ "tF", 101 }, { "̪", 101 }, { "ӂ", 101 },
		{ "tH", 102 }, { "̫", 102 }, { "ӂ", 102 },
		{ "t", 103 }, { "̬", 103 }, { "ӂ", 103 },
		{ "t", 104 }, { "̭", 104 }, { "ӂ", 104 },
		{ "t", 105 }, { "̮", 105 }, { "ӂ", 105 },
		{ "o", 106 }, { "", 106 }, { "", 106 },
		{ "r", 107 }, { "", 107 }, { "", 107 },
		{ "u", 108 }, { "", 108 }, { "", 108 },
		{ "x", 109 }, { "", 109 }, { "", 109 },
		{ "{", 110 }, { "", 110 }, { "", 110 },
		{ "r", 111 }, { "ެ", 111 }, { "т", 111 },
		{ "r", 112 }, { "ޭ", 112 }, { "т", 112 },
		{ "rF", 113 }, { "ު", 113 }, { "т", 113 },
		{ "r", 114 }, { "ޮ", 114 }, { "т", 114 },
		{ "p", 115 }, { "", 115 }, { "", 115 },
		{ "s", 116 }, { "", 116 }, { "", 116 },
		{ "v", 117 }, { "", 117 }, { "", 117 },
		{ "y", 118 }, { "", 118 }, { "", 118 },
		{ "|", 119 }, { "", 119 }, { "", 119 },
		{ "s", 120 }, { "߬", 120 }, { "҂", 120 },
		{ "s", 121 }, { "߭", 121 }, { "҂", 121 },
		{ "sF", 122 }, { "ߪ", 122 }, { "҂", 122 },
		{ "s", 123 }, { "߮", 123 }, { "҂", 123 },
		{ "}", 124 }, { "", 124 }, { "", 124 },
		{ "~", 125 }, { "", 125 }, { "", 125 },
		{ "", 126 }, { "", 126 }, { "", 126 },
		{ "", 127 }, { "", 127 }, { "", 127 },
		{ "", 128 }, { "", 128 }, { "", 128 },
		{ "~", 129 }, { "Ь", 129 }, { "݂", 129 },
		{ "~", 130 }, { "Э", 130 }, { "݂", 130 },
		{ "~F", 131 }, { "Ъ", 131 }, { "݂", 131 },
		{ "~", 132 }, { "Ю", 132 }, { "݂", 132 },
		{ "", 133 }, { "", 133 }, { "", 133 },
		{ "", 134 }, { "", 134 }, { "", 134 },
		{ "CF", 135 }, { "", 135 }, { "", 135 },
		{ "", 136 }, { "", 136 }, { "", 136 },
		{ "", 137 }, { "", 137 }, { "", 137 },
		{ "", 138 }, { "", 138 }, { "", 138 },
		{ "", 139 }, { "", 139 }, { "", 139 },
		{ "", 140 }, { "", 140 }, { "", 140 },
		{ "", 141 }, { "", 141 }, { "", 141 },
		{ "", 142 }, { "ج", 142 }, { "", 142 },
		{ "", 143 }, { "ح", 143 }, { "", 143 },
		{ "F", 144 }, { "ت", 144 }, { "肥", 144 },
		{ "", 145 }, { "خ", 145 }, { "", 145 },
		{ "", 146 }, { "", 146 }, { "", 146 },
		{ "EB", 147 }, { "", 147 }, { "", 147 },
		{ "ED", 148 }, { "", 148 }, { "", 148 },
		{ "EF", 149 }, { "", 149 }, { "", 149 },
		{ "EH", 150 }, { "", 150 }, { "", 150 },
		{ "@", 151 }, { "ާ", 151 },
		{ "B", 152 }, { "ި", 152 },
		{ "", 153 }, { "", 153 },
		{ "F", 154 }, { "ު", 154 },
		{ "H", 155 }, { "ޫ", 155 },
		{ "", 156 }, { "", 156 }, { "", 156 },
		{ "[", 255 }, { "", 255 },
		{ NULL, 0 }
	};
	int i, n = -1;

	for(i = 0; table[i].ch != NULL; i++)
		if(strncmp(*p, table[i].ch, strlen(table[i].ch)) == 0 && (n < 0 || strlen(table[i].ch) > strlen(table[n].ch)))
			n = i;
	if(n < 0)
		return FALSE;

	*command = table[n].command;
	(*p) += strlen(table[n].ch);
	return TRUE;
}

/*
	𐔒lɕϊ(16i)
*/
static int atoix(const char *buf)
{
	int result;

	sscanf(buf, "%x", &result);
	return result;
}

int main(int argc, char *argv[])
{
	const int wavelength[] = {
		108,	/* 2C  */
		105,	/* 2C# */
		102,	/* 2D  */
		99,	/* 2D# */
		96,	/* 2E  */
		93,	/* 2F  */
		90,	/* 2F# */
		87,	/* 2G  */
		84,	/* 2G# */
		81,	/* 2A  */
		78,	/* 2A# */
		75,	/* 2B  */
		72,	/* 3C  */
		69,	/* 3C# */
		66,	/* 3D  */
		63,	/* 3D# */
		60,	/* 3E  */
		57,	/* 3F  */
		54,	/* 3F# */
		51,	/* 3G  */
		48,	/* 3G# */
		45,	/* 3A  */
		42,	/* 3A# */
		39,	/* 3B  */
		36,	/* 4C  */
		33,	/* 4C# */
		30,	/* 4D  */
		26,	/* 4D# */
		23,	/* 4E  */
		20,	/* 4F  */
		17,	/* 4F# */
		14,	/* 4G  */
		11,	/* 4G# */
		8,	/* 4A  */
		6,	/* 4A# */
		3	/* 4B  */
	};
	const int base_time[] = {
		960000,	/* 2C  */
		1015804,	/* 2C# */
		1074852,	/* 2D  */
		1137333,	/* 2D# */
		1203446,	/* 2E  */
		1273401,	/* 2F  */
		1347424,	/* 2F# */
		1425749,	/* 2G  */
		1508627,	/* 2G# */
		1596323,	/* 2A  */
		1689117,	/* 2A# */
		1787304,	/* 2B  */
		1920000,	/* 3C  */
		2031608,	/* 3C# */
		2149705,	/* 3D  */
		2274666,	/* 3D# */
		2406892,	/* 3E  */
		2546803,	/* 3F  */
		2694848,	/* 3F# */
		2851498,	/* 3G  */
		3017255,	/* 3G# */
		3192646,	/* 3A  */
		3378234,	/* 3A# */
		3574609,	/* 3B  */
		3840000,	/* 4C  */
		4063217,	/* 4C# */
		4299410,	/* 4D  */
		4549333,	/* 4D# */
		4813784,	/* 4E  */
		5093607,	/* 4F  */
		5389696,	/* 4F# */
		5702997,	/* 4G  */
		6034510,	/* 4G# */
		6385293,	/* 4A  */
		6756468,	/* 4A# */
		7149218,	/* 4B  */
	};
	struct {
		int wavelength; /* g */
		int voice; /*  */
		int time1; /* o͎ */
		int time2; /* o̖͌ */
		int rest; /* x? */
	} data[8192], *sound_p = data, *voice_p = data;
	FILE *fp;
	int command, length, period, slur, note, t = 120, l = 4, q = 7, o = 3, trans = 0, line = 0;
	char buf[0x1000 * 32], address[64], path[PATH_MAX], *p;

	/* \[XJ */
	if(argv[1] == NULL) {
		fprintf(stderr, "USAGE: %s [̃f[^t@C] [AhX܂̓x]\n", argv[0]);
		return 1;
	}
	if((fp = fopen (argv[1], "rt")) == NULL) {
		fprintf(stderr, "CANNOT OPEN %s\n", argv[1]);
		return 1;
	}

	/* x܂̓AhX𓾂 */
	if(argv[2] != NULL)
		strcpy(address, argv[2]);
	else
		sprintf(address, "0x%04x", ADDRESS);

	while(fgets(buf, sizeof(buf), fp) != NULL) {
		line++;
		p = buf;

		/* sԍǂݔ΂ */
		while(*p != 0 && isdigit((unsigned char)*p))
			p++;

		while(*p != 0) {
			/* 󔒂ǂݔ΂ */
			skipBlank(&p);

			if(*p == ';') {
				/* Rg */
				break;
			} else if(getSound(&command, &length, &period, &slur, &p)) {
				if(command == COMMAND_T) {
					/* e| */
					t = length;
				} else if(command == COMMAND_L) {
					/*  */
					l = length;
				} else if(command == COMMAND_Q) {
					/* Q */
					q = length;
				} else if(command == COMMAND_O) {
					/* IN^[u */
					o = length;
				} else if(command == COMMAND_INC) {
					/* 1IN^[uグ */
					o++;
				} else if(command == COMMAND_DEC) {
					/* 1IN^[u */
					o--;
				} else if(command == COMMAND_TRANS) {
					/* ڒ */
					trans = length;
				} else if(command == COMMAND_TRANS_MINUS) {
					/* ڒ */
					trans = -length;
				} else {
					/* ȗ̉𓾂 */
					if(length == 0)
						length = l;

					if(command == COMMAND_R) {
						/* x */
						note = 12;
						sound_p->rest = TRUE;
					} else {
						/*  */
						note = command + (o - 2) * 12 + trans;
						if(note < 0) {
							fprintf(stderr, "Ⴗ (%d:%d)\n", line, (int )(p - buf));
							return 1;
						}
						if(note >= sizeof(wavelength) / sizeof(wavelength[0]) - 1) {
							fprintf(stderr, " (%d:%d)\n", line, (int )(p - buf));
							return 1;
						}
						sound_p->rest = FALSE;
					}

					/* g߂ */
					sound_p->wavelength = wavelength[note];

					/* ̒߂ */
					sound_p->time1 = base_time[note] / t / length;
					if(period)
						sound_p->time1 += sound_p->time1 / 2;
					sound_p->time2 = 0;
					if(sound_p->time1 > 0x10000) {
						fprintf(stderr, " (%d:%d)\n", line, (int )(p - buf));
						return 1;
					}

					/* L[I/L[ItԂݒ肷 */
					if(!slur) {
						sound_p->time2 = sound_p->time1 * (8 - q) / 8;
						sound_p->time1 = sound_p->time1 - sound_p->time2;
					}

					/* I[ */
					sound_p++;
					sound_p->wavelength = 0;
				}
			} else if(getVoice(&command, &p)) {
				/* xȂ特R}h܂Ŗɂ */
				while(voice_p->rest) {
					voice_p->voice = 0;
					voice_p++;
				}

				/* ǂzĂ邩? */
				if (sound_p < voice_p) {
					fprintf(stderr, "ƉĂ (%d:%d)\n", line, (int )(p - buf));
					return 1;
				}

				/*  */
				voice_p->voice = command;
				voice_p++;
			} else if(*p != 0) {
				/* sȃR}h */
				fprintf(stderr, "sȃR}h (%d:%d)\n", line, (int )(p - buf));
				return 1;
			}
		}
	}

	/* xȂ特R}h܂Ŗɂ */
	while(voice_p->rest) {
		voice_p->voice = 0;
		voice_p++;
	}

	/* R}hĂ邩? */
	if(sound_p != voice_p) {
		fprintf(stderr, "Ȃ \n");
		return 1;
	}

	fclose(fp);

	if(strncasecmp(address, "0x", 2) == 0) { /* AhXw肩? */
		/* ɏ */
		p = buf;
		for(sound_p = data; sound_p->wavelength != 0; sound_p++) {
			*p++ = sound_p->wavelength;
			*p++ = sound_p->voice;
			*p++ = sound_p->time1 & 0xff;
			*p++ = sound_p->time1 >> 8;
			*p++ = sound_p->time2 & 0xff;
			*p++ = sound_p->time2 >> 8;
		}
		*p++ = 0;

		/* Intel HEX `ŕۑ */
		sprintf(path, "%s.hex", argv[1]);
		if(writeHexAbs(path, buf, atoix(address + 2), (int )(p - buf)) <= 0) {
			fprintf(stderr, "݂Ɏs܂\n");
			return 1;
		}
		fprintf(stderr, "%s %04x-%04x\n", path, atoix(address + 2), atoix(address + 2) + (int )(p - buf) - 1);
	} else {
		/* AZũ\[XƂĕۑ */
		printf("%s::\n", address);
		for(sound_p = data; sound_p->wavelength != 0; sound_p++) {
			printf("\t.db 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x\n",
			sound_p->wavelength,
			sound_p->voice,
			sound_p->time1 & 0xff,
			sound_p->time1 >> 8,
			sound_p->time2 & 0xff,
			sound_p->time2 >> 8
			);
		}
		printf("\t.db 0\n");
	}
	return 0;
}

/* eof */
